### dijkstra-knoten.py

# Das Programm benoetigt die ausgegliederten Funktionen:
from funktionen import first,second,last,rest,cons
# und
from prioritaetswarteschlange import *
# mit der Funktion fuege_alle_ein(<neue wegeliste>, vor, <priows>)
# Das Praedikat vor muss dafuer explizit passend definiert werden:
def vor(weg_1, weg_2):
    return first(weg_1) < first(weg_2)
# und
from gallenbacher_graph_knoten import *
# Verwendet wird davon hier das Dictionary gallenbacherGraph
# und die Zugriffsfunktion holeNachfolger
# und
from wege import *
# Verwendet wird die Funktion alle-nachfolge-wege(<weg>, <graph>)

### =============== Entwurfsprinzip fuer Dijksta ===============
### Durch das Verwenden der Prioritaetswarteschlange ist gewaehrleistet,
### dass nur die kuerzesten Wege zu einem Knoten verwendet werden.
### Varianten:
# - Es wird nur der kuerzeste Weg zu einem Zielknoten gesucht.
# - Es werden alle kuerzesten Wege vom Startknoten aus gesucht.
### Entwurfsentscheidung: Variante 1 wird bearbeitet.

### ===== Dijksta =====
# Loesung mit passender Aufrufhuelle
def dijkstra(start_knoten, ziel_knoten, graph):
    return dijkstra_intern([start_knoten],     # besuchtliste
                           [],                 # kuerzeste_wege
                           fuegeAlleEin(     # Start-PrioWS
                               alleNachfolgeWege(
                                   [0, start_knoten], # Start-'Weg'
                                   graph),
                               vor,
                               []),
                           ziel_knoten,
                           graph)

def dijkstra_intern(besucht, kuerzeste_wege, priows, ziel_knoten, graph):
##    print(besucht, kuerzeste_wege, priows, ziel_knoten,'\n\n')
##    input('weiter?')
    if len(priows)==0: return False
    if last(first(priows)) == ziel_knoten:
        ##print(cons(first(priows), kuerzeste_wege))
        print("Loesung: ")
        print(first(priows))
        return first(priows)
    if last(first(priows)) in besucht:
        return dijkstra_intern(besucht,
                               kuerzeste_wege,
                               rest(priows),
                               ziel_knoten,
                               graph)
    return dijkstra_intern(
        aktualisiereBesuchtliste(second(first(priows)), besucht),
        aktualisisereKuerzesteWege(besucht, first(priows), kuerzeste_wege),
        aktualisierePriows(priows, graph),
        ziel_knoten,
        graph)


### ===== Hilfsfunktion aktualisiereBesuchtliste =====
def aktualisiereBesuchtliste(knoten, besucht):
    if knoten in besucht: # keine Anderung
        return besucht
    return cons(knoten, besucht)

### ===== Hilfsfunktion aktualisierePriows =====
# Zum ersten Weg aus der Prioritaetswarteschlange werden alle weiter
# fuehrenden wege des Graphen bestimmt
# und in den Rest der priows eingefuegt
def aktualisierePriows(priows, graph):
    return fuegeAlleEin (alleNachfolgeWege(first(priows),graph),
                         vor,
                         rest(priows))

### ===== Hilfsfunktion aktualisisereKuerzesteWege =====
# Nur neu erreichte Knoten ergeben einen kuerzesten Weg
def aktualisisereKuerzesteWege(besucht, weg, kuerzeste_wege):
    if second(weg) in besucht:
        return kuerzeste_wege
    else:
        return cons(weg, kuerzeste_wege)
    
#-----
# Tests dijkstra:
dijkstra('I', 'M', gallenbacherGraph) # -> [43, 'I', 'M']
dijkstra('I', 'O', gallenbacherGraph) # -> [123, 'I', 'P', 'K', 'F', 'O']
dijkstra('A', 'E', gallenbacherGraph) # -> [126, 'A', 'N', 'Z', 'Y', 'K', 'E']
dijkstra('P', 'G', gallenbacherGraph) # -> [75, 'P', 'K', 'Y', 'G']
