# gallenbacher_graph_knoten.py
# der Typ Dictionary (Klasse!) entspricht dem Typ Assoziationsliste von Scheme
# Dieser Ansatz ist nicht objekt-orientiert!

gallenbacherGraph={
    'A' : [['B', 69], ['D', 36], ['M', 36], ['N', 22]],
    'B' : [['A', 69], ['D', 64], ['Z', 32], ['H', 30], ['I', 34], ['X', 26]],
    'C' : [['I', 40], ['M', 31], ['X', 23]],
    'D' : [['A', 36], ['B', 64], ['L', 95], ['N', 20]],
    'E' : [['F', 79], ['G', 60], ['K', 31], ['O', 102]],
    'F' : [['E', 79], ['K', 29], ['O', 14], ['P', 57]],
    'G' : [['E', 60], ['K', 58], ['L', 58], ['Y', 30]],
    'H' : [['B', 30], ['I', 65], ['K', 31], ['L', 106], ['P', 34], ['Y', 29]],
    'I' : [['B', 34], ['C', 40], ['H', 65], ['M', 43], ['P', 55]],
    'K' : [['E', 31], ['F', 29], ['G', 58], ['H', 31], ['P', 25], ['Y', 20]],
    'L' : [['D', 95], ['G', 58], ['H', 106], ['Z', 40]],
    'M' : [['A', 36], ['C', 31], ['I', 43], ['X', 12]],
    'N' : [['A', 22], ['D', 20], ['X', 29], ['Z', 30]],
    'O' : [['E', 102], ['F', 14], ['P', 91]],
    'P' : [['F', 57], ['H', 34], ['I', 55], ['K', 25], ['O', 91]],
    'X' : [['B', 26], ['C', 23], ['M', 12], ['N', 29]],
    'Y' : [['G', 30], ['H', 29], ['K', 20], ['Z', 23]],
    'Z' : [['B', 32], ['L', 40], ['N', 30], ['Y', 23]]
}

### ----- holeKante -----
### Gibt zu zwei Knoten und dem Graphen [Knotenliste] die Kante zurueck.
### Die Funktion gibt bei fehlender Kante eine leere Liste zurueck,
### ist damit gegen fehlerhafte Knoteneingaben abgesichert.
def holeKante(von, nach, graph):
    if (von in graph):
        for kante in graph[von]:
            if kante[0]==nach:
                return [von]+kante
        return []
    return []

### Test:
##print(holeKante('L', 'H', gallenbacherGraph)) ### -> [L H 106]
##print(holeKante('Q', 'H', gallenbacherGraph)) ### -> []

### ----- holeNachfolger -----
### Gibt zu einem Knoten und dem Graphen [Knotenliste] eine Liste von Listen
### der Nachfolgeknoten mit den Kantenbewertungen zurueck.
### Die Funktion gibt bei fehlendem Knoten eine leere Liste zurueck,
### ist damit gegen fehlerhafte Knoteneingaben abgesichert.
def holeNachfolger(von, graph):
    if not von in graph: return []
    return graph[von]

##print(holeNachfolger('L', gallenbacherGraph)) ### -> [[D 95] [G 58] [H 106] [Z 40]]
##print(holeNachfolger('Q', gallenbacherGraph)) ### -> []


