### wege.py
### stellt die Funktionen fuer die Verwaltung der Wege bereit,
### wenn die Knotenliste verwendet wird

from funktionen import first,second,last,rest,cons
from gallenbacher_graph_knoten import *
# Verwendet wird davon das Dictionary gallenbacherGraph
# und die Zugriffsfunktion holeNachfolger(<aktuelle-stadt> , <graph>)

### ===== Hilfsfunktion neuerWeg =====
# Gibt zu einem Weg und zu einer Kante den verlaengerten Weg zurueck.
def neuerWeg(weg, kante):
    '''die Kante wird mit dem von-Knoten am Kopf uebergeben
    [von, nach, Bewertung]'''
    if not last(weg)==first(kante):
        print('Fehler:', last(weg),'<>',second(kante))
        return weg
    neuerWeg=[first(weg)+last(kante)]+weg[1:]+[kante[1]]
    return neuerWeg

# Wege sind Listen aus der Laenge und den besuchten Knoten
# (diese vorwaerts sortiert, wegen des Hinzufuegens mit append)
# Muster: [60, X, B, I]

### ===== alleNachfolgeWege =====
### iterative Variante
# gibt zum aktuellen Weg alle Wege zurueck, die sich aus den
# Nachfolgekanten der Knotenliste (zB zu C: [[I 40] [M 31] [X 23]] ergeben.
##def alleNachfolgeWege(weg, graph):
##    nachfolger=holeNachfolger(last(weg), graph) # ohne den aktuellen Knoten
##    neueWege=[]
##    for nF in nachfolger:
##        neueWege.append(neuerWeg(weg,[last(weg)]+nF))
##    return neueWege
### rekursive Alternative 
def alleNachfolgeWege(weg, graph):
    # aktuelle-stadt steht am Ende im weg
    return alleBearbeitung(holeNachfolger(last(weg), graph), weg)
        
    
def alleBearbeitung(die_nachfolger, weg):
    if len(die_nachfolger)==0:
        return []
    elif first(first(die_nachfolger)) in weg: # nicht zurueck
       return alleBearbeitung(rest(die_nachfolger), weg)
    else:
        return cons(neuerWeg(weg, cons(last(weg), first(die_nachfolger))),
                    alleBearbeitung(rest(die_nachfolger), []+weg))
        

#Tests:
##print(neuerWeg ([34, 'I', 'B'], [26, 'B', 'X']))
### -> [60, 'I', 'B', 'X']
# Tests:
#print(alleNachfolgeWege([56, 'A', 'D', 'N'], gallenbacherGraph))
### -> [[85, 'A', 'D', 'N', 'X'], [86, 'A', 'D', 'N', 'Z']]
